package Libtool::Link;


sub execute
  {
  my $verCurrent = undef;
  my $verRevision = undef;
  my $verAge = undef;
  my $installDir = undef;
  my $targetIsExecutable = undef;
  my $targetbasename = undef;
  my $target = undef;
  my @tool_args = ();
  my @object_files = ( );
  my @libraries = ("ws2_32");
  my @libdirs = ();

  while(@_)
    {
    # target
    my $currentArg = shift;
    #print "$currentArg\n";
    if ($currentArg =~ '-o')
      {
      $currentArg = shift;
      if ($currentArg =~ /(.*)\.la/)
        {
        $targetbasename = $1;
        $target = ".libs/".$1.".dll.a";
        }
      else
        {
        $targetIsExecutable = 1;
        $target = $currentArg;
        }
      }
    elsif ($currentArg =~ '-rpath')
      {
      $currentArg = shift;
      $installDir = $currentArg;
      }
    elsif ($currentArg =~ '-version-info')
      {
      $currentArg = shift;
      if($currentArg =~ /([0-9]*)(.*)/)
        {
        $verCurrent = $1;
        my $secondPart = $2;
        if($secondPart =~ /:([0-9]*)(.*)/)
          {
          $verRevision = $1;
          my $thirdPart = $2;
          if($thirdPart =~ /:([0-9]*)(.*)/)
            {
            $verAge = $1;
            }
          }
        }

      }
    # object files
    elsif ($currentArg =~ /(.*)\.lo/)
      {
      my $lo_file = $currentArg;
      my $object_file = ".libs/".$1.".o";
      push @object_files,$object_file;
      }
    # libraries
    elsif ($currentArg =~ /(.*)\.la/)
      {
      my $libbasename = $1;
      push @libraries,$libbasename;
      }
    # libraries
    elsif ($currentArg =~ /-l(.*)/)
      {
      my $libbasename = $1;
      push @libraries,$libbasename;
      }
    elsif ($currentArg =~ /-L(.*)/)
      {
      my $libdir = $1;
      push @libdirs,$libdir;
      }
    # other arguments
    else
      {
      push @tool_args, $currentArg;
      }
    }
  if($targetIsExecutable)
    {
    @commandline = ("gcc","-shared","-mthreads","-mno-cygwin");
    push @commandline,@object_files;

    push @commandline,"-L".$installDir;
    if( -e ".libs")
      {
      push @commandline,"-L./.libs";
      }

    foreach(@libdirs)
      {
      my $libdir = "-L".$_;
      push @commandline,$libdir;
      }
    foreach(@libraries)
      {
      my $lib = "-l".$_;
      push @commandline,$lib;
      }
    push @commandline,"-o";
    push @commandline,$target;

    if (system (@commandline) != 0)
      {
      exit($?);
      }
    }
  else
    {
    my $library_file=".libs/".$targetbasename.".dll.a";
    my $def_file=".libs/".$targetbasename.".def";
    my $exports_file = ".libs/".$targetbasename."_dll_export_definitions.o";
    my @commandline = ("dlltool","-D",".libs/$targetbasename.dll","--export-all-symbols","-e","$exports_file","-l","$library_file","-z","$def_file");
    push @commandline,@object_files;
    push @object_files,$exports_file;
    #print @commandline;
    if (system (@commandline) != 0)
      {
      exit($?);
      }
    @commandline = ("gcc","-shared","-mthreads","-mno-cygwin");
    push @commandline,@object_files;
    
    push @commandline,"-L".$installDir;
    push @commandline,"-L./.libs";
    
    foreach(@libdirs)
      {
      my $libdir = "-L".$_;
      push @commandline,$libdir;
      }
    foreach(@libraries)
      {
      my $lib = "-l".$_;
      push @commandline,$lib;
      }
    push @commandline,"-o";
    push @commandline,".libs/$targetbasename.dll";

    if (system (@commandline) != 0)
      {
      exit($?);
      }
      
    if(-e ".libs/$targetbasename.dll")
      {
      open(FH, ">","$targetbasename.la");
      print FH "# $targetbasename.la - a libtool library file\n";
      print FH "# Generated by Ajasoft libtool for win32\n";
      print FH "#\n";
      print FH "# Please DO NOT delete this file!\n";
      print FH "# It is necessary for linking the library.\n";
      print FH "\n";
      print FH "# The name that we can dlopen(3).\n";
      print FH "dlname='$targetbasename.dll'\n";
      print FH "\n";
      print FH "# Names of this library.\n";
      print FH "library_names='$targetbasename.dll.a'\n";
      print FH "\n";
      print FH "# The name of the static archive.\n";
      print FH "old_library=''\n";
      print FH "\n";
      print FH "# Libraries that this one depends upon.\n";
      print FH "dependency_libs=' '\n";
      print FH "\n";
      print FH "# Version information for $targetbasename.\n";
      print FH "current=$verCurrent\n";
      print FH "age=$verAge\n";
      print FH "revision=$verRevision\n";
      print FH "\n";
      print FH "# Is this an already installed library?\n";
      print FH "installed=no\n";
      print FH "\n";
      print FH "# Should we warn about portability when linking against -modules?\n";
      print FH "shouldnotlink=no\n";
      print FH "\n";
      print FH "# Files to dlopen/dlpreopen\n";
      print FH "dlopen=''\n";
      print FH "dlpreopen=''\n";
      print FH "\n";
      print FH "# Directory that this library needs to be installed in:\n";
      print FH "libdir='$installDir'\n";
      close(FH);
      }
    }

  }

sub show_help
  {


  }


1;
